﻿************************************************************************************************************************************************************************************************
/PLEASE READ THE FOLLOWING MESSAGES VERY CAREFULLY BEFORE PROCEEDING TO USE GUMSCORE SPSS PROGRAM
This program is a modification of the more general GUMSCORE SPSS program and conducts expected a posteriori (EAP) scoring for use ONLY with the 20-item
UFFM-I Conscientiousness measure;
Use of this program requires the following citation in published research:
Carter & LoPilato (2014). GUMSCORE SPSS: A SPSS Macro for fixed-item-parameter scoring under the generalized graded unfolding model. Athens, GA: University
of Georgia.
*To use the program the following steps should be taken:
1. Download the UFFM-I CONSCORE folder directly to C:\ drive
2. Enter your data into the Resp_File.sav file and save without changing the location of the file (The data MUST include case numbers in the variable labeled CASE
and item responses MUST be coded from 0=Strongly Disagree to 5=Strongly Agree); One case is currently included in this file as an example and should be 
deleted to run your own data; Responses must be entered in the same order as in the included UFFM-I Conscientiousness Item Content 
3. Run the syntax below by FIRST selected everything but the first line and pressing run and then selecting the first line and pressing run
4. Check the Results_Theta_SE.sav file for respondent scores in the variable Theta_EAP and the standard errors of their scores SE_THETA_EAP
EAP scores produced by this program can be interpreted similarly to a z-score and represent the number of standard deviatons above or below the mean of 0
NOTE: It is normal to have errors in the Output of SPSS; this is NOT an indication of problems with the program
NOTE: Currently, these programs cannot estimate scores for respondents that do not answer all questions; this issues is currently being addressed
NOTE: No variable names should be changed and no variables should be deleted in any file; All files must retain their original location and should not be altered,
with the exception of entering data (see above)
************************************************************************************************************************************************************************************************

!conscscore C=5 / i=20 / K=6 / p=1.

DEFINE !conscscore (C = !CHAREND('/') / i = !CHAREND('/') / p = !CHAREND('/') / K = !CHAREND('/')). 
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\GGUM_ItemPars.SAV'.
COMPUTE C=!C.
COMPUTE K=!K.
EXECUTE.
VECTOR t_=t_1 to t_8.
LOOP j=1 to !K.
VECTOR st_(!K).
END LOOP.
DO IF !K>1.
END IF.
LOOP j=1 to !K.
COMPUTE st_(j)=sum(st_(j-1),(t_(j))).
END LOOP.
EXECUTE.
DELETE VARIABLES t_1 to j.
EXECUTE.
MATRIX.
GET a / VARIABLES a.
COMPUTE ai=transpos(a).
MSAVE ai 
   / TYPE=MEAN
   / VARIABLES = a1 to a100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\apar.sav'.
END MATRIX.
MATRIX.
GET d / VARIABLES d.
COMPUTE di=transpos(d).
MSAVE di 
   / TYPE=MEAN
   / VARIABLES = d1 to d100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\dpar.sav'.
END MATRIX.
MATRIX.
GET st_0 / VARIABLES t_0.
COMPUTE sti_0 = transpos(st_0).
MSAVE sti_0 
   / TYPE=MEAN
   / VARIABLES = st_0_i1 to st_0_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_0par.sav'.
END MATRIX.
MATRIX.
GET st_1 / VARIABLES st_1.
COMPUTE sti_1 = transpos(st_1).
MSAVE sti_1 
   / TYPE=MEAN
   / VARIABLES = st_1_i1 to st_1_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_1par.sav'.
END MATRIX.
MATRIX.
GET st_2 / VARIABLES st_2.
COMPUTE sti_2 = transpos(st_2).
MSAVE sti_2
   / TYPE=MEAN
   / VARIABLES = st_2_i1 to st_2_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_2par.sav'.
END MATRIX.
MATRIX.
GET st_3 / VARIABLES st_3.
COMPUTE sti_3 = transpos(st_3).
MSAVE sti_3
   / TYPE=MEAN
   / VARIABLES = st_3_i1 to st_3_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_3par.sav'.
END MATRIX.
MATRIX.
GET st_4 / VARIABLES st_4.
COMPUTE sti_4 = transpos(st_4).
MSAVE sti_4
   / TYPE=MEAN
   / VARIABLES = st_4_i1 to st_4_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_4par.sav'.
END MATRIX.
MATRIX.
GET st_5 / VARIABLES st_5.
COMPUTE sti_5 = transpos(st_5).
MSAVE sti_5
   / TYPE=MEAN
   / VARIABLES = st_5_i1 to st_5_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_5par.sav'.
END MATRIX.
MATRIX.
GET st_6 / VARIABLES st_6.
COMPUTE sti_6 = transpos(st_6).
MSAVE sti_6
   / TYPE=MEAN
   / VARIABLES = st_6_i1 to st_6_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_6par.sav'.
END MATRIX.
MATRIX.
GET st_7 / VARIABLES st_7.
COMPUTE sti_7 = transpos(st_7).
MSAVE sti_7
   / TYPE=MEAN
   / VARIABLES = st_7_i1 to st_7_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_7par.sav'.
END MATRIX.
MATRIX.
GET st_8 / VARIABLES st_8.
COMPUTE sti_8 = transpos(st_8).
MSAVE sti_8
   / TYPE=MEAN
   / VARIABLES = st_8_i1 to st_8_i100
   / OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st_8par.sav'.
END MATRIX.

GET FILE='C:\UFFM-I CONSCSCORE\COMPS\apar.sav'.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\dpar.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_0par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_1par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_2par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_3par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_4par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_5par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_6par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_7par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\st_8par.sav'
  /RENAME (ROWTYPE_ VARNAME_ = x0 x11) 
  /DROP= x0 x11.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS.SAV'.
EXECUTE.

GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS.SAV'.
EXECUTE.
COMPUTE PARNUM=1.
EXECUTE.
RECODE PARNUM (1=30) INTO #NUMROWS.
LOOP COPY=1 TO #NUMROWS.
XSAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_ALL.SAV' / KEEP=COPY ALL.
END LOOP.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_ALL.SAV'.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\QUADRATURES.sav'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_ALL.SAV'.
EXECUTE.
COMPUTE Af=PDF.NORMAL(Quad,0,1).
EXECUTE.

COMPUTE p=!p.
EXECUTE.
COMPUTE NUMPEOPLE=1.
EXECUTE.
RECODE COPY (1=!p) INTO #NUMPEOPLE.
LOOP COPY=1 TO #NUMPEOPLE.
XSAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_READYFORPEOPLE.SAV' / KEEP=COPY ALL.
END LOOP.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_READYFORPEOPLE.SAV'.
EXECUTE.
SORT CASES BY COPY(A).
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_READYFORPEOPLE.SAV' / KEEP=COPY ALL.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\Resp_File.SAV'.
EXECUTE.
COMPUTE CASENUM=$CASENUM.
EXECUTE.
RECODE CASENUM (1=30) INTO #NUMQUADS.
LOOP COPY=1 TO #NUMQUADS.
XSAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\Resp_File_MAKE.SAV' / KEEP=COPY ALL.
END LOOP.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\Resp_File_make.SAV'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\Resp_File_make.SAV'.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_READYFORPEOPLE.SAV'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
COMPUTE M=2*!C+1.
EXECUTE.
COMPUTE W0=0.
COMPUTE W1=1.
COMPUTE W2=2.
COMPUTE W3=3.
COMPUTE W4=4.
COMPUTE W5=5.
COMPUTE W6=6.
COMPUTE W7=7.
COMPUTE W8=8.
RECODE case to casenum (-9=SYSMIS).
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.

GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\a matrix.SAV'
  /KEEP=a1 to d1
  /COMPRESSED.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\a matrix.SAV'.
EXECUTE.
DELETE VARIABLES d1.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\a matrix.SAV'.
EXECUTE.

GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\d matrix.SAV'
  /KEEP=d1 to st_0_i1
  /COMPRESSED.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\d matrix.SAV'.
EXECUTE.
DELETE VARIABLES st_0_i1.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\d matrix.SAV'.
EXECUTE.

GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st matrix.SAV'
  /KEEP=st_0_i1 to PARNUM
  /COMPRESSED.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\st matrix.SAV'.
EXECUTE.
DELETE VARIABLES PARNUM.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\st matrix.SAV'.
EXECUTE.



GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
LOOP k=1 TO !i.
VECTOR a=a1 to d1.
VECTOR d=d1 to st_0_i1.
VECTOR st_0_i=st_0_i1 to st_1_i1.
VECTOR st_1_i=st_1_i1 to st_2_i1.
VECTOR st_2_i=st_2_i1 to st_3_i1.
VECTOR st_3_i=st_3_i1 to st_4_i1.
VECTOR st_4_i=st_4_i1 to st_5_i1.
VECTOR st_5_i=st_5_i1 to st_6_i1.
VECTOR st_6_i=st_6_i1 to st_7_i1.
VECTOR st_7_i=st_7_i1 to st_8_i1.
VECTOR st_8_i=st_8_i1 to st_9_i1.
ELSE IF k=!C.
VECTOR st_(k)_i=st_(k)_i1 to parnum.
END IF.
END LOOP.
END LOOP.
LOOP k=1 TO !i.
VECTOR denom_O0(!i).
VECTOR denom_O1(!i).
VECTOR denom_O2(!i).
VECTOR denom_O3(!i).
VECTOR denom_O4(!i).
VECTOR denom_O5(!i).
VECTOR denom_O6(!i).
VECTOR denom_O7(!i).
VECTOR denom_O8(!i).
COMPUTE denom_O0(k)=exp(a(k)*(W0*(QUAD-d(k))-st_0_i(k)))+exp(a(k)*((M-W0)*(QUAD-d(k))-st_0_i(k))).
COMPUTE denom_O1(k)=exp(a(k)*(W1*(QUAD-d(k))-st_1_i(k)))+exp(a(k)*((M-W1)*(QUAD-d(k))-st_1_i(k))).
COMPUTE denom_O2(k)=exp(a(k)*(W2*(QUAD-d(k))-st_2_i(k)))+exp(a(k)*((M-W2)*(QUAD-d(k))-st_2_i(k))).
COMPUTE denom_O3(k)=exp(a(k)*(W3*(QUAD-d(k))-st_3_i(k)))+exp(a(k)*((M-W3)*(QUAD-d(k))-st_3_i(k))).
COMPUTE denom_O4(k)=exp(a(k)*(W4*(QUAD-d(k))-st_4_i(k)))+exp(a(k)*((M-W4)*(QUAD-d(k))-st_4_i(k))).
COMPUTE denom_O5(k)=exp(a(k)*(W5*(QUAD-d(k))-st_5_i(k)))+exp(a(k)*((M-W5)*(QUAD-d(k))-st_5_i(k))).
COMPUTE denom_O6(k)=exp(a(k)*(W6*(QUAD-d(k))-st_6_i(k)))+exp(a(k)*((M-W6)*(QUAD-d(k))-st_6_i(k))).
COMPUTE denom_O7(k)=exp(a(k)*(W7*(QUAD-d(k))-st_7_i(k)))+exp(a(k)*((M-W7)*(QUAD-d(k))-st_7_i(k))).
COMPUTE denom_O8(k)=exp(a(k)*(W8*(QUAD-d(k))-st_8_i(k)))+exp(a(k)*((M-W8)*(QUAD-d(k))-st_8_i(k))).
VECTOR denom_i(!i).
COMPUTE x=$sysmis.
COMPUTE denom_i(k)=sum(denom_O0(k),denom_O1(k),denom_O2(k),denom_O3(k),denom_O4(k),denom_O5(k),denom_O6(k),denom_O7(k),denom_O8(k)).

VECTOR i_=i_1 to CASENUM.

VECTOR pi_(!i).
DO IF i_(k)=0.
COMPUTE pi_(k)=denom_O0(k)/denom_i(k).
END IF.
DO IF i_(k)=1.
COMPUTE pi_(k)=denom_O1(k)/denom_i(k).
END IF.
DO IF i_(k)=2.
COMPUTE pi_(k)=denom_O2(k)/denom_i(k).
END IF.
DO IF i_(k)=3.
COMPUTE pi_(k)=denom_O3(k)/denom_i(k).
END IF.
DO IF i_(k)=4.
COMPUTE pi_(k)=denom_O4(k)/denom_i(k).
END IF.
DO IF i_(k)=5.
COMPUTE pi_(k)=denom_O5(k)/denom_i(k).
END IF.
DO IF i_(k)=6.
COMPUTE pi_(k)=denom_O6(k)/denom_i(k).
END IF.
DO IF i_(k)=7.
COMPUTE pi_(k)=denom_O7(k)/denom_i(k).
END IF.
DO IF i_(k)=8.
COMPUTE pi_(k)=denom_O8(k)/denom_i(k).
END IF.

COMPUTE z=$sysmis.
VECTOR prod_(!i).
COMPUTE prod_1=pi_1.
DO IF k>1.
END IF.
COMPUTE prod_(k)=prod_(k-1)*pi_(k).
COMPUTE LVf=prod_(k).
END LOOP.
EXECUTE.
COMPUTE theta_numer=Quad*Af*LVf.
COMPUTE thetaANDse_denom=Af*LVf.
EXECUTE.

AGGREGATE
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=case
  /theta_numer_sum=SUM(theta_numer) 
  /thetaANDse_denom_sum=SUM(thetaANDse_denom).
COMPUTE theta=theta_numer_sum/thetaANDse_denom_sum.
EXECUTE.
COMPUTE se_numer=((Quad-theta)**2)*Af*LVf.
EXECUTE.

AGGREGATE
  /OUTFILE=* MODE=ADDVARIABLES
  /BREAK=case
  /se_numer_sum=SUM(se_numer).

COMPUTE se_theta=SQRT(se_numer_sum/thetaANDse_denom_sum).
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.SAV'.
EXECUTE.

SORT CASES BY case.
AGGREGATE
  /OUTFILE='C:\UFFM-I CONSCSCORE\RESULTS_Theta_SE.sav'
  /PRESORTED
  /BREAK=case
  /theta_mean=MEAN(theta) 
  /se_theta_mean=MEAN(se_theta).

GET FILE='C:\UFFM-I CONSCSCORE\RESULTS_Theta_SE.sav'.
EXECUTE.
MATCH FILES /FILE=*
  /FILE='C:\UFFM-I CONSCSCORE\Resp_File.SAV'
  /RENAME (case = d0) 
  /DROP= d0.

RENAME VARIABLES (theta_mean se_theta_mean = theta_EAP se_theta_EAP.
EXECUTE.
SAVE OUTFILE='C:\UFFM-I CONSCSCORE\RESULTS_Theta_SE.sav'.
EXECUTE.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\a matrix.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\d matrix.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_0par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_1par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_2par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_3par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_4par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_5par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_6par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_7par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st_8par.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\apar.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\dpar.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_READYFORPEOPLE.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\ALLPARS.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\st matrix.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\Resp_File_make.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\ALLPARS_ALL.sav'.
ERASE FILE 'C:\UFFM-I CONSCSCORE\COMPS\ALL_FORCOMP.sav'.
EXECUTE.
GET FILE='C:\UFFM-I CONSCSCORE\RESULTS_Theta_SE.sav'.
EXECUTE.
!ENDDEFINE.